package com.ejie.ab39a.control;

import com.ejie.ab39a.service.EjeService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.Eje;

/**
 * EjeController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/eje")

public class EjeController {

	private static final Logger logger = LoggerFactory.getLogger(EjeController.class);

	@Autowired
	private EjeService ejeService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idEje
	 *            Long idEje
	 * @return Eje Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idEje}", method = RequestMethod.GET)
	public @ResponseBody Eje get(@PathVariable Long idEje) {
		Eje eje = new Eje();
		eje.setIdEje(idEje);
		eje = this.ejeService.find(eje);
		EjeController.logger.info("[GET - findBy_PK] : Obtener Eje por PK");
		return eje;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterEje
	 *            Eje Objeto que contiene los parametros de filtrado utilizados
	 *            en la busqueda.
	 * @return List<Eje> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Eje> getAll(@ModelAttribute Eje filterEje) {
		EjeController.logger.info("[GET - find_ALL] : Obtener Eje por filtro");
		return this.ejeService.findAll(filterEje, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param eje
	 *            Eje Bean que contiene la informacion a modificar.
	 * @return Eje Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Eje edit(@RequestBody Eje eje) {
		Eje ejeAux = this.ejeService.update(eje);
		EjeController.logger.info("[PUT] : Eje actualizado correctamente");
		return ejeAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param eje
	 *            Eje Bean que contiene la informacion con la que se va a crear
	 *            el nuevo registro.
	 * @return Eje Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Eje add(@RequestBody Eje eje) {
		Eje ejeAux = this.ejeService.add(eje);
		EjeController.logger.info("[POST] : Eje insertado correctamente");
		return ejeAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idEje
	 *            Long Identificador del objeto que se desea eliminar.
	 * @return Eje Bean eliminado.
	 */
	@RequestMapping(value = "/{idEje}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Eje remove(@PathVariable Long idEje) {
		Eje eje = new Eje();
		eje.setIdEje(idEje);
		this.ejeService.remove(eje);
		EjeController.logger.info("[DELETE] : Eje borrado correctamente");
		return eje;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		EjeController.logger.info("[GET - View] : eje");
		return "eje";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterEje
	 *            Eje Bean que contiene los parametros de filtrado a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Eje> Dto que contiene el resultado del filtrado
	 *         realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Eje> filter(@RequestJsonBody(param = "filter") Eje filterEje,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EjeController.logger.info("[POST - filter] : Obtener Ejes");
		return this.ejeService.filter(filterEje, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterEje
	 *            Eje Bean que contiene los parametros de filtrado a emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Eje filterEje,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		EjeController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Ejes");
		this.ejeService.removeMultiple(filterEje, jqGridRequestDto, false);
		EjeController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
